#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <amx_settings_api>
#include <cs_weap_models_api>
#include <fun>
#include <xs>
#include <zombieplague>

#define ZP_TEAM_ASSASSIN (1<<5)

new g_iEscape;

// Settings file
new const g_szViewFrogModel[] = "models/mod/v_bomb_origin_zombi.mdl"
new const g_szPlayerFrogModel[] = "models/mod/p_zombibomb.mdl"
new const g_szWorldFrogModel[] = "models/mod/w_zombibomb.mdl"

new g_ItemID, g_SprFrogExp
new Array:g_sound_grenade_frog_explode

// HACK: pev_ field used to store custom nade types and their values
const PEV_NADE_TYPE = pev_flTimeStepSound
const NADE_TYPE_FROG = 6666

new pCvar_FrogKnockWaveRadius, pCvar_FrogKnockWave, pCvar_FrogMaxDamage

public plugin_precache()
{
	new szMapName[32];
	get_mapname(szMapName, 31)
	
	if (containi(szMapName, "escape") != -1 || containi(szMapName, "ze_") != -1 || containi(szMapName, "atix") != -1)
	{
		g_iEscape = true;
		
		return;
	}
	
	new const ZP_SETTINGS_FILE[] = "zpnm-zc_item_frog_bomb.ini"
	
	new const ZC_SOUNDS_SECTION[] = "Sounds"
	new const ZC_SOUNDS_FROG_EXPLODE[] = "GRENADE FROG EXPLODE"
	
	new const ZC_SPRITES_SECTION[] = "Sprites"
	new const ZC_SPRITES_FROG_EXPLODE[] = "GRENADE FROG RING"
	
	new const szExplodeFrogSound[] = "mod/zombi_bomb_exp.wav"
	
	new szExplodeFrogSprite[] = "sprites/mod/zombiebomb.spr"

	// Initialize arrays
	g_sound_grenade_frog_explode = ArrayCreate(64, 1)
	
	// Load from external file
	amx_load_setting_string_arr(ZP_SETTINGS_FILE, ZC_SOUNDS_SECTION, ZC_SOUNDS_FROG_EXPLODE, g_sound_grenade_frog_explode)
	
	// If we couldn't load custom sounds from file, use and save default ones
	new index
	if (ArraySize(g_sound_grenade_frog_explode) == 0)
	{
//		for (index = 0; index < sizeof szExplodeFrogSound; index++)
		ArrayPushString(g_sound_grenade_frog_explode, szExplodeFrogSound) //[index]
		
		// Save to external file
		amx_save_setting_string_arr(ZP_SETTINGS_FILE, ZC_SOUNDS_SECTION, ZC_SOUNDS_FROG_EXPLODE, g_sound_grenade_frog_explode)
	}

	if (!amx_load_setting_string(ZP_SETTINGS_FILE, ZC_SPRITES_SECTION, ZC_SPRITES_FROG_EXPLODE, szExplodeFrogSprite, charsmax(szExplodeFrogSprite)))
		amx_save_setting_string(ZP_SETTINGS_FILE, ZC_SPRITES_SECTION, ZC_SPRITES_FROG_EXPLODE, szExplodeFrogSprite)

	// Precache sounds
	new szModel[64]
	for (index = 0; index < ArraySize(g_sound_grenade_frog_explode); index++)
	{
		ArrayGetString(g_sound_grenade_frog_explode, index, szModel, charsmax(szModel))
		precache_sound(szModel)
	}
	
	g_SprFrogExp = precache_model(szExplodeFrogSprite)
	
	precache_model(g_szViewFrogModel)
	precache_model(g_szPlayerFrogModel)
	precache_model(g_szWorldFrogModel)
}

public plugin_init()
{
	register_plugin("[zpnm-zc] Item: Frog Bomb", "0.1.2", "bogdyutzu, D i 5 7 i n c T")
	
	register_forward(FM_SetModel, "fw_SetModel")
	RegisterHam(Ham_Spawn, "player", "fwHamSpawnPlayerPre")
	RegisterHam(Ham_Think, "grenade", "fw_ThinkGrenade")
	
	g_ItemID = zp_register_extra_item("Frog Bomb", 5, ZP_TEAM_ZOMBIE | ZP_TEAM_NEMESIS | ZP_TEAM_ASSASSIN)//zp_items_register("Frog Bomb", 5)
	
	pCvar_FrogKnockWaveRadius = register_cvar("zc_item_frog_knockwave_radius", "240.0");
	pCvar_FrogKnockWave = register_cvar("zc_item_frog_knockwave_power", "1000.0");
	pCvar_FrogMaxDamage = register_cvar("zc_item_frog_knockwave_damage", "5.0");
}
/*
public plugin_natives()
{
	set_module_filter("module_filter");
	set_native_filter("native_filter");
}

public zp_fw_items_select_pre(id, itemid, ignorecost)
{
	// This is not our item
	if (itemid != g_ItemID)
		return ZP_ITEM_AVAILABLE;
	
	// Infection bomb only available to zombies
	if (!zp_core_is_zombie(id))
		return ZP_ITEM_DONT_SHOW;
	
	// Player already owns infection bomb
	if (user_has_weapon(id, CSW_FLASHBANG))
		return ZP_ITEM_NOT_AVAILABLE;
	
	return ZP_ITEM_AVAILABLE;
}*/

public zp_extra_item_selected(id, itemid) //zp_fw_items_select_post(id, itemid, ignorecost)
{
	// This is not our item
	if (itemid != g_ItemID)
		return PLUGIN_CONTINUE;
	
	if (g_iEscape)
	{
		client_print(id, print_center, "This item is disabled during escape maps!")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	if (user_has_weapon(id, CSW_FLASHBANG))
		return ZP_PLUGIN_HANDLED;
	
	// Give infection bomb
//	give_frog(id)
	give_item(id, "weapon_flashbang")
	
	return PLUGIN_CONTINUE;
}

public fwHamSpawnPlayerPre(id)
{
	if (g_iEscape || !is_user_connected(id))
		return;
	
	// Remove custom grenade model
	cs_reset_player_weap_model(id, CSW_FLASHBANG);
	cs_reset_player_view_model(id, CSW_FLASHBANG);
}

public zp_user_infected_post(id) //zp_fw_class_zombie_select_post(id, classid)
{
	if (g_iEscape)
		return;
/*	
	if(!is_user_alive(id)) return;
	
	static szFrogModel[64];
	zc_class_zombie_get_frog_model(classid, szFrogModel, charsmax(szFrogModel));*/
	
	// Set custom grenade model
	cs_set_player_view_model(id, CSW_FLASHBANG, g_szViewFrogModel) //szFrogModel
	cs_set_player_weap_model(id, CSW_FLASHBANG, g_szPlayerFrogModel);
/*	
	if (!user_has_weapon(id, CSW_FLASHBANG))
//		set_task(0.1, "give_frog",id)
		give_item(id, "weapon_flashbang")*/
}

public zp_user_humanized_post(id) //zp_fw_core_cure(id, attacker)
{
	if (g_iEscape)
		return;
	
	// Remove custom grenade model
	cs_reset_player_weap_model(id, CSW_FLASHBANG);
	cs_reset_player_view_model(id, CSW_FLASHBANG);
}
/*
public give_frog(id)
{
	if(is_user_alive(id))
		give_item(id, "weapon_flashbang")
}*/

// Forward Set Model
public fw_SetModel(entity, const model[])
{
	if (g_iEscape)
		return FMRES_IGNORED;
	
	// We don't care
	if (strlen(model) < 8)
		return FMRES_IGNORED;
	
	// Narrow down our matches a bit
	if (model[7] != 'w' || model[8] != '_')
		return FMRES_IGNORED;
	
	// FB Grenade
	if (model[9] == 'f' && model[10] == 'l')
	{
		// Get damage time of grenade
		static Float:dmgtime
		pev(entity, pev_dmgtime, dmgtime)
		
		// Grenade not yet thrown
		if (dmgtime == 0.0)
			return FMRES_IGNORED;
		
		// Grenade's owner isn't zombie?
		if (!zp_get_user_zombie(pev(entity, pev_owner))) //zp_core_is_zombie
			return FMRES_IGNORED;
	
		engfunc(EngFunc_SetModel, entity, g_szWorldFrogModel);
		
		new Float:aVelocity[ 3 ]
		aVelocity[ 0 ] = random_float( -100.0, -500.0 )
		
		set_pev( entity, pev_avelocity, aVelocity )
		
		// Set grenade type on the thrown grenade entity
		set_pev(entity, PEV_NADE_TYPE, NADE_TYPE_FROG)
		return FMRES_SUPERCEDE;
	}
	return FMRES_IGNORED;
}

// Ham Grenade Think Forward
public fw_ThinkGrenade(entity)
{
	if (g_iEscape)
		return HAM_IGNORED;
	
	// Invalid entity
	if (!pev_valid(entity)) return HAM_IGNORED;
	
	// Get damage time of grenade
	static Float:dmgtime
	pev(entity, pev_dmgtime, dmgtime)
	
	// Check if it's time to go off
	if (dmgtime > get_gametime())
		return HAM_IGNORED;
	
	// Check if it's one of our custom nades
	switch (pev(entity, PEV_NADE_TYPE))
	{
		case NADE_TYPE_FROG: // Frog Bomb
		{
			frog_explode(entity)
			return HAM_SUPERCEDE;
		}
	}
	return HAM_IGNORED;
}

frog_explode(ent, Float:originF[3] = {0.0, ...})
{
	// Round ended
	if (zp_has_round_started() != 1) //zp_gamemodes_get_current() == ZP_NO_GAME_MODE
	{
		// Get rid of the grenade
		engfunc(EngFunc_RemoveEntity, ent)
		return;
	}
	
	pev(ent, pev_origin, originF)
	FX_Explosion(originF, g_SprFrogExp, 40, 60, 10)
	
	// Explode sound
	new  sound[64]
	ArrayGetString(g_sound_grenade_frog_explode, random_num(0, ArraySize(g_sound_grenade_frog_explode) - 1), sound, charsmax(sound))
	emit_sound(ent, CHAN_WEAPON, sound, 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	// Get attacker
	new attacker = pev(ent, pev_owner)

	// Infection bomb owner disconnected or not zombie anymore?
	if (!is_user_connected(attacker) || !zp_get_user_zombie(attacker)) //zp_core_is_zombie
	{
		// Get rid of the grenade
		engfunc(EngFunc_RemoveEntity, ent)
		return;
	}
	
	new Float:radius = get_pcvar_float(pCvar_FrogKnockWaveRadius);
	Explode(ent, radius, get_pcvar_float(pCvar_FrogKnockWave), get_pcvar_float(pCvar_FrogMaxDamage));
	//UTIL_ScreenShake(originF, 4.0, 10.0, 2.0, radius);
		
	// Get rid of the grenade
	engfunc(EngFunc_RemoveEntity, ent)	
}

FX_Explosion(const Float:flOrigin[], const iSprite, const iScale, const iFramerate, const iFlags)
{
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, flOrigin, 0);
	write_byte(TE_EXPLOSION);
	engfunc(EngFunc_WriteCoord, flOrigin[0]);
	engfunc(EngFunc_WriteCoord, flOrigin[1]);
	engfunc(EngFunc_WriteCoord, flOrigin[2]);
	write_short(iSprite);
	write_byte(iScale);
	write_byte(iFramerate);
	write_byte(iFlags);
	message_end();
	
	engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, flOrigin, 0);
	write_byte(TE_TAREXPLOSION);
	engfunc(EngFunc_WriteCoord, flOrigin[0])
	engfunc(EngFunc_WriteCoord, flOrigin[1]);
	engfunc(EngFunc_WriteCoord, flOrigin[2]);
	message_end();	
}

Explode(iEntity, Float:flRadius, Float:flMaxThrowSpeed, Float:flMaxDamage)
{
	new Float:vecEntityOrigin[3];
	pev(iEntity, pev_origin, vecEntityOrigin);

	new iPlayer,
		Float:vecPlayerOrigin[3],
		Float:vecVelocity[3],
		Float:flDistance,
		//Float:flPercent,
		//Float:flSpeed,
		//Float:flDamage,
		Float:fl_Time
	
	while((iPlayer = engfunc(EngFunc_FindEntityInSphere, iPlayer, vecEntityOrigin, flRadius)))
	{
		if(is_user_alive(iPlayer))
		{
			pev(iPlayer, pev_origin, vecPlayerOrigin);
			/*
			xs_vec_sub(vecPlayerOrigin, vecEntityOrigin, vecVelocity);
			
			flDistance = vector_length(vecVelocity);
			flPercent = 1.0 - flDistance / flRadius;
			flSpeed = flPercent * flMaxThrowSpeed;
			flDamage = flPercent * flMaxDamage;
			
			xs_vec_mul_scalar(vecVelocity, flSpeed / flDistance, vecVelocity);
			
			set_pev(iPlayer, pev_velocity, vecVelocity);
			*/
			
			pev(iPlayer, pev_origin, vecPlayerOrigin)
			flDistance = get_distance_f(vecPlayerOrigin, vecEntityOrigin)
			
			fl_Time = flDistance / flMaxThrowSpeed
			
			vecVelocity[0] = ((vecPlayerOrigin[0] - vecEntityOrigin[0]) / fl_Time)// * 1.5
			vecVelocity[1] = ((vecPlayerOrigin[1] - vecEntityOrigin[1]) / fl_Time)// * 1.5
			vecVelocity[2] = (vecPlayerOrigin[2] - vecEntityOrigin[2]) / fl_Time
			
			set_pev(iPlayer, pev_velocity, vecVelocity)
			
			//HookEnt(iPlayer, vecEntityOrigin, flMaxThrowSpeed)
			
			if (!zp_get_user_zombie(iPlayer))
				ExecuteHamB(Ham_TakeDamage, iPlayer, iEntity, iEntity, flMaxDamage - (flMaxDamage / flRadius * flDistance), DMG_BLAST);
		}
	}
}

/*
// Credits to Dias
stock HookEnt(ent, Float:VicOrigin[3], Float:speed)
{
	static Float:fl_Velocity[3]
	static Float:EntOrigin[3]
	
	pev(ent, pev_origin, EntOrigin)
	static Float:distance_f
	distance_f = get_distance_f(EntOrigin, VicOrigin)
	
	static Float:fl_Time; fl_Time = distance_f / speed
	
	fl_Velocity[0] = ((EntOrigin[0] - VicOrigin[0]) / fl_Time)// * 1.5
	fl_Velocity[1] = ((EntOrigin[1] - VicOrigin[1]) / fl_Time)// * 1.5
	fl_Velocity[2] = (EntOrigin[2] - VicOrigin[2]) / fl_Time

	set_pev(ent, pev_velocity, fl_Velocity)
}*/