/*
To do:

T = needs testing
X = done
- = cancelled

[T] register Ham_Killed instead of using zpnm killed native
[T] CZ bots support
[T] is_user_alive
v1.1.3
[T] overall rewrite, added item drop
v2.0.0
[ ] 
*/

// Modules
#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
#include <cs_ham_bots_api>
#include <zombieplaguenightmare>

// Stocks
#include <bitsums>



#define NO_RECOIL_WEAPONS_BITSUM (1<<2 | 1<<CSW_KNIFE | 1<<CSW_HEGRENADE | 1<<CSW_FLASHBANG | 1<<CSW_SMOKEGRENADE | 1<<CSW_C4)

new g_iIDItem, g_iBsAliveHuman, g_iBsItemHave, g_iIDPCVarRound, g_iIDPCVarGive, g_iIDPCVarDrop, g_iPlayersMax;

new const g_szItemClassName[] = "D7NoRecoil";
new const g_szItemModelW[] = "models/w_security.mdl";

//new g_iIDSpriteDot;

ftClientPrintChatColor(const iIDTarget = 0, const iIDSender = 0, const szMessage[], any:...)
{
	if (iIDTarget && !is_user_connected(iIDTarget))
		return;
	
	static szBuffer[192];
	vformat(szBuffer, charsmax(szBuffer), szMessage, 4)
	
	static const szChatTag[] = "^1[^4ZPNM^1] ";
	format(szBuffer, charsmax(szBuffer), "%s%s", szChatTag, szBuffer)
	
	static iIDMsgSayText;
	if (!iIDMsgSayText)
		iIDMsgSayText = get_user_msgid("SayText");
	
	if (iIDTarget)
		message_begin(MSG_ONE, iIDMsgSayText, _, iIDTarget)
	else
		message_begin(MSG_ALL, iIDMsgSayText)
	
	write_byte(!iIDSender ? iIDTarget : iIDSender)
	write_string(szBuffer)
	message_end()
}

public plugin_precache()
{
	precache_model(g_szItemModelW)
	
	new szItemModelWT[sizeof g_szItemModelW + 1]
	formatex(szItemModelWT, charsmax(g_szItemModelW) - 4, g_szItemModelW)
	format(szItemModelWT, charsmax(szItemModelWT), "%sT.mdl", szItemModelWT)
	
	if (file_exists(szItemModelWT))
		precache_model(szItemModelWT)
	
	//g_iIDSpriteDot = precache_model("sprites/dot.spr");
}

public plugin_init()
{
	register_plugin("[ZPNM] No Recoil", "2.0.0", "BW-Chocolate, D i 5 7 i n c T")
	
	register_dictionary("zpnm_no_recoil.txt")
	
	register_event("HLTV", "fwEvHLTVRoundStart", "a", "1=0", "2=0")
	
	register_touch(g_szItemClassName, "player", "fwTouchItemPlayer")
	
	RegisterHam(Ham_Spawn, "player", "fwHamSpawnPlayerPre")
	RegisterHam(Ham_Spawn, "player", "fwHamSpawnPlayer", 1)
	RegisterHam(Ham_Killed, "player", "fwHamKilledPlayer", 1)
	
	#if defined _cs_ham_bots_api_included
	RegisterHamBots(Ham_Spawn, "fwHamSpawnPlayerPre")
	RegisterHamBots(Ham_Spawn, "fwHamSpawnPlayer", 1)
	RegisterHamBots(Ham_Killed, "fwHamKilledPlayer", 1)
	#endif
	
	g_iIDItem = zp_register_extra_item("No Recoil", 11, ZP_TEAM_HUMAN | ZP_TEAM_SURVIVOR | ZP_TEAM_SNIPER)
	
	new i, szWeapon[20];
	
	for (i = CSW_P228; i <= CSW_P90; i++)
		if (!(NO_RECOIL_WEAPONS_BITSUM & (1 << i)) && get_weaponname(i, szWeapon, charsmax(szWeapon)))
			RegisterHam(Ham_Weapon_PrimaryAttack, szWeapon, "fwHamWeaponPrimaryAttack", 1);
	
	g_iPlayersMax = get_maxplayers();
	
	g_iIDPCVarRound = register_cvar("zpnm_no_recoil_round", "0")
	g_iIDPCVarGive = register_cvar("zpnm_no_recoil_give", "0")
	g_iIDPCVarDrop = register_cvar("zpnm_no_recoil_drop", "1")
}

public fwEvHLTVRoundStart()
{
	new iIDEnt = g_iPlayersMax;
	
	while ((iIDEnt = engfunc(EngFunc_FindEntityByString, iIDEnt, "classname", g_szItemClassName)) != 0)
	{
		if (!pev_valid(iIDEnt))
			continue;
		
		engfunc(EngFunc_RemoveEntity, iIDEnt)
	}
}

public client_disconnect(iID)
{
	if (get_pcvar_num(g_iIDPCVarDrop))
		ftItemDrop(iID)
	
	bitsum_del(g_iBsAliveHuman, iID)
}

public zp_extra_item_selected(iID, iIDItem)
{
	if (iIDItem != g_iIDItem)
		return PLUGIN_CONTINUE;
	
	if (bitsum_get(g_iBsItemHave, iID))
	{
		ftClientPrintChatColor(iID, 33, "^3%L", iID, "ZPNM_NO_RECOIL_HAVE_ALREADY")
		
		return ZP_PLUGIN_HANDLED;
	}
	
	bitsum_add(g_iBsItemHave, iID)
	
	ftClientPrintChatColor(iID, iID, "^4%L", iID, "ZPNM_NO_RECOIL_HAVE")
	
	return PLUGIN_CONTINUE;
}

public fwHamSpawnPlayerPre(const iID)
{
	bitsum_add(g_iBsAliveHuman, iID)
	
	if (get_pcvar_num(g_iIDPCVarRound))
		bitsum_del(g_iBsItemHave, iID)
	else if (get_pcvar_num(g_iIDPCVarGive))
		bitsum_add(g_iBsItemHave, iID)
}

public fwHamSpawnPlayer(const iID)
{
	if (!is_user_alive(iID))
	{
		bitsum_del(g_iBsAliveHuman, iID)
		bitsum_del(g_iBsItemHave, iID)
		
		return;
	}
}

public fwHamWeaponPrimaryAttack(const iIDEnt)
{
	new iID = pev(iIDEnt, pev_owner);
	
	if (bitsum_get(g_iBsItemHave, iID))
		set_pev(iID, pev_punchangle, Float:{ 0.0, 0.0, 0.0 });
}

public zp_user_infected_post(iID)
{
	if (get_pcvar_num(g_iIDPCVarDrop))
		ftItemDrop(iID)
	
	bitsum_del(g_iBsAliveHuman, iID)
}

public zp_user_humanized_post(iID)
{
	if (get_pcvar_num(g_iIDPCVarGive))
		bitsum_add(g_iBsItemHave, iID)
	
	bitsum_add(g_iBsAliveHuman, iID)
}

public fwHamKilledPlayer(const iID)
{
	if (get_pcvar_num(g_iIDPCVarDrop) && zp_has_round_started())
		ftItemDrop(iID)
	
	bitsum_del(g_iBsAliveHuman, iID)
}

public ftItemDrop(iID)
{
	if (!bitsum_get(g_iBsItemHave, iID) || get_pcvar_num(g_iIDPCVarGive))
		return;
	
	new iIDEnt = create_entity("info_target");
	
	if (!is_valid_ent(iIDEnt))
		return;
	
	entity_set_string(iIDEnt, EV_SZ_classname, g_szItemClassName)
	engfunc(EngFunc_SetSize, iIDEnt, Float:{ -4.0, -4.0, 0.0 }, Float:{ 4.0, 4.0, 2.0 })
	//set_pev(iIDEnt, pev_mins, Float:{ -5.0, -5.0, 0.0 })
	//set_pev(iIDEnt, pev_maxs, Float:{ 5.0, 5.0, 2.0 })
	engfunc(EngFunc_SetModel, iIDEnt, g_szItemModelW)
	set_pev(iIDEnt, pev_rendermode, kRenderNormal)
	set_pev(iIDEnt, pev_renderfx, kRenderFxGlowShell)
	set_pev(iIDEnt, pev_renderamt, random_float(25.0, 30.0))
	set_pev(iIDEnt, pev_rendercolor, Float:{ 0.0, 255.0, 0.0 })
	set_pev(iIDEnt, pev_solid, SOLID_TRIGGER)
	set_pev(iIDEnt, pev_movetype, MOVETYPE_TOSS)
	
	new Float:fOrigin[3], Float:fVelocity[3];
	
	pev(iID, pev_origin, fOrigin)
	set_pev(iIDEnt, pev_origin, fOrigin)
	
	pev(iID, pev_angles, fOrigin)
	fOrigin[0] = 0.0;
	set_pev(iIDEnt, pev_angles, fOrigin)
	
	velocity_by_aim(iID, 250, fOrigin)
	pev(iID, pev_velocity, fVelocity)
	
	fVelocity[0] += fOrigin[0];
	fVelocity[1] += fOrigin[1];
	fVelocity[2] += fOrigin[2];
	
	set_pev(iIDEnt, pev_velocity, fVelocity)
	
	//fwTaskEntShowSize(iIDEnt)
	//set_task(0.1, "fwTaskEntShowSize", iIDEnt, _, _, "b")
	
	bitsum_del(g_iBsItemHave, iID)
}

public fwTouchItemPlayer(iIDEnt, iID)
{
	if (iID < 1 || iID > g_iPlayersMax || !bitsum_get(g_iBsAliveHuman, iID) || bitsum_get(g_iBsItemHave, iID))
		return;
	
	engfunc(EngFunc_RemoveEntity, iIDEnt)
	
	bitsum_add(g_iBsItemHave, iID)
	
	ftClientPrintChatColor(iID, iID, "^4%L", iID, "ZPNM_NO_RECOIL_HAVE")
}
/*
#include <xs>

public fwTaskEntShowSize(const id)
{
	if (!is_valid_ent(id))
	{
		remove_task(id)
		
		return;
	}
	
	static Float:fVecTemp[3], Float:fVecTemp2[3], Float:fVecTemp3[3]//, Float:fVecTemp4[3];
	pev(id, pev_origin, fVecTemp)
	pev(id, pev_mins, fVecTemp2)
	pev(id, pev_maxs, fVecTemp3)
	//pev(id, pev_view_ofs, fVecTemp4)
	
	xs_vec_add(fVecTemp, fVecTemp2, fVecTemp2)
	xs_vec_add(fVecTemp, fVecTemp3, fVecTemp3)
	
	DrawLine(id, fVecTemp3[0], fVecTemp3[1], fVecTemp3[2], fVecTemp2[0], fVecTemp3[1], fVecTemp3[2], 255, 255, 255);
	DrawLine(id, fVecTemp3[0], fVecTemp3[1], fVecTemp3[2], fVecTemp3[0], fVecTemp2[1], fVecTemp3[2], 255, 255, 255);
	DrawLine(id, fVecTemp3[0], fVecTemp3[1], fVecTemp3[2], fVecTemp3[0], fVecTemp3[1], fVecTemp2[2], 255, 255, 255);
	DrawLine(id, fVecTemp2[0], fVecTemp2[1], fVecTemp2[2], fVecTemp3[0], fVecTemp2[1], fVecTemp2[2], 255, 255, 255);
	DrawLine(id, fVecTemp2[0], fVecTemp2[1], fVecTemp2[2], fVecTemp2[0], fVecTemp3[1], fVecTemp2[2], 255, 255, 255);
	DrawLine(id, fVecTemp2[0], fVecTemp2[1], fVecTemp2[2], fVecTemp2[0], fVecTemp2[1], fVecTemp3[2], 255, 255, 255);
	DrawLine(id, fVecTemp2[0], fVecTemp3[1], fVecTemp3[2], fVecTemp2[0], fVecTemp3[1], fVecTemp2[2], 255, 255, 255);
	DrawLine(id, fVecTemp2[0], fVecTemp3[1], fVecTemp2[2], fVecTemp3[0], fVecTemp3[1], fVecTemp2[2], 255, 255, 255);
	DrawLine(id, fVecTemp3[0], fVecTemp3[1], fVecTemp2[2], fVecTemp3[0], fVecTemp2[1], fVecTemp2[2], 255, 255, 255);
	DrawLine(id, fVecTemp3[0], fVecTemp2[1], fVecTemp2[2], fVecTemp3[0], fVecTemp2[1], fVecTemp3[2], 255, 255, 255);
	DrawLine(id, fVecTemp3[0], fVecTemp2[1], fVecTemp3[2], fVecTemp2[0], fVecTemp2[1], fVecTemp3[2], 255, 255, 255);
	DrawLine(id, fVecTemp2[0], fVecTemp2[1], fVecTemp3[2], fVecTemp2[0], fVecTemp3[1], fVecTemp3[2], 255, 255, 255);
	
	DrawLine(id, fVecTemp2[0], fVecTemp2[1], fVecTemp2[2], fVecTemp3[0], fVecTemp3[1], fVecTemp3[2], 0, 255, 0);
	DrawLine(id, fVecTemp2[0], fVecTemp2[1], fVecTemp3[2], fVecTemp3[0], fVecTemp3[1], fVecTemp2[2], 0, 255, 0);
	DrawLine(id, fVecTemp2[0], fVecTemp3[1], fVecTemp2[2], fVecTemp3[0], fVecTemp2[1], fVecTemp3[2], 0, 255, 0);
	DrawLine(id, fVecTemp3[0], fVecTemp2[1], fVecTemp2[2], fVecTemp2[0], fVecTemp3[1], fVecTemp3[2], 0, 255, 0);
}

#define fm_write_coord(%1)				engfunc(EngFunc_WriteCoord, %1)

DrawLine(const id, const Float:x1, const Float:y1, const Float:z1, const Float:x2, const Float:y2, const Float:z2, const r, const g, const b)
{
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY, _, 0);
	{
		write_byte(TE_BEAMPOINTS);
		fm_write_coord(x1);
		fm_write_coord(y1);
		fm_write_coord(z1);
		fm_write_coord(x2);
		fm_write_coord(y2);
		fm_write_coord(z2);
		write_short(g_iIDSpriteDot);
		write_byte(1);	// framestart 
		write_byte(1);	// framerate 
		write_byte(1);	// life in 0.1's 
		write_byte(2);	// width
		write_byte(0);	// noise 
		write_byte(r);	// r, g, b 
		write_byte(g);	// r, g, b 
		write_byte(b);	// r, g, b 
		write_byte(200);	// brightness 
		write_byte(0);	// speed 
	}
	message_end();
}
*/