/*
To do:

T = needs testing
X = done
- = cancelled

[X] RegisterHamBots instead of zpnm_register_ham_bots
[X] constant function parameters where it's the case
[X] fix damage printing even if it's blocked
[X] descriptive variable / function / forward names for easier code readability
v0.2.4
[T] fix damage not resetting or resetting wrongfully
[T] add breakable entities support
[T] add float damage support
v0.2.7
[T] make sure damage was taken
[T] correct friendly fire damage
[T] connected check for attacker before displaying hud
[T] show integer values for player damage and float for entities
[T] optional cz bot support
v0.3.2
[ ] add armor damage support
[ ] customizable damage reset time
[ ] spectator support
[ ] remember show after disconnect
[ ] remember show after map change
[ ] support for (cz?) hostages
[ ] support for all disconnect cases
[ ] dynamic chat command
[ ] 
*/

// Modules
#include <amxmodx>
//#include <fakemeta>
#include <hamsandwich>

// Plug-in APIs
// Comment the next include to make it work without CZ bot support
#include <cs_ham_bots_api>
// Comment the next include to make it work without ZPNM
#include <zombieplaguenightmare>

// Stocks
#include <bitsums>

enum (+= 32)
{
	g_iIDTaskResetGiven = 1000,
	g_iIDTaskResetTaken
}

new g_iMaxPlayers, g_iIDMsgSyncHud, g_iBsDontShow, Float:g_fDamageTaken[33], Float:g_fDamageGiven[33], g_iHealth;

public plugin_init()
{
	register_plugin("[ZPNM] Damage Displayer", "0.3.2", "D i 5 7 i n c T")
	
	register_dictionary("D7_damage_display.txt")
	
	RegisterHam(Ham_TakeDamage, "player", "fwHamTakeDamagePlayerPre")
	RegisterHam(Ham_TakeDamage, "player", "fwHamTakeDamagePlayerBreakable", 1)
	RegisterHam(Ham_TakeDamage, "func_breakable", "fwHamTakeDamagePlayerBreakable", 1)
	
	#if defined _cs_ham_bots_api_included
	RegisterHamBots(Ham_TakeDamage, "fwHamTakeDamagePlayerPre")
	RegisterHamBots(Ham_TakeDamage, "fwHamTakeDamagePlayerBreakable", 1)
	#endif
	
	//register_clcmd("say /dmg", "fwClCmdSayDmg")
	register_clcmd("say /bd", "fwClCmdSayBd")
	register_clcmd("say_team /bd", "fwClCmdSayBd")
	
	g_iMaxPlayers = get_maxplayers();
	g_iIDMsgSyncHud = CreateHudSyncObj();
}

public client_putinserver(iID)
	bitsum_del(g_iBsDontShow, iID)

public client_disconnect(iID)
{
	remove_task(iID + g_iIDTaskResetTaken)
	remove_task(iID + g_iIDTaskResetGiven)
	
	bitsum_add(g_iBsDontShow, iID)
	
	g_fDamageGiven[iID] = 0.0;
	g_fDamageTaken[iID] = 0.0;
}
/*
public fwClCmdSayDmg(const iID)
{
	ExecuteHamB(Ham_TakeDamage, iID, 0, iID, random_float(0.01, 0.99), (1<<1))//DMG_BULLET
}*/

public fwClCmdSayBd(const iID)
{
	if (!bitsum_get(g_iBsDontShow, iID))
	{
		bitsum_add(g_iBsDontShow, iID)
		
		client_print(iID, print_center, "[D7] %L", iID, "D7_DAMAGE_DISPLAY_OFF")
	}
	else
	{
		bitsum_del(g_iBsDontShow, iID)
		
		client_print(iID, print_center, "[D7] %L", iID, "D7_DAMAGE_DISPLAY_ON")
	}
}

public fwHamTakeDamagePlayerPre(const iIDVictim)//, const iIDInflictor, const iIDAttacker, const Float:fDamage
{
	g_iHealth = get_user_health(iIDVictim);
}

public fwHamTakeDamagePlayerBreakable(const iIDVictim, const iIDInflictor, const iIDAttacker, Float:fDamage)
{
	if (1 <= iIDVictim <= g_iMaxPlayers)
	{
		fDamage = 1.0 * g_iHealth - get_user_health(iIDVictim);
		
		if (!fDamage)
			return;
	}
	
	if (GetHamReturnStatus() == HAM_SUPERCEDE)
		return;
	
	ftDamageDisplay(iIDVictim, iIDAttacker, fDamage)
}

#if defined _zombieplaguenightmare_included
public zpnm_user_burn(iIDVictim, iIDAttacker, iDamage, bPost)
	if (bPost)
		ftDamageDisplay(iIDVictim, iIDAttacker, float(iDamage))
#endif

ftDamageDisplay(const iIDVictim, const iIDAttacker, const Float:fDamage)
{
	if ((1 <= iIDVictim <= g_iMaxPlayers) && !bitsum_get(g_iBsDontShow, iIDVictim))
	{
		g_fDamageTaken[iIDVictim] += fDamage;
		
		set_hudmessage(255, 0, 0, 0.3, 0.55, 1, 2.0, 0.0, 0.0, 2.0, 3)
		ShowSyncHudMsg(iIDVictim, g_iIDMsgSyncHud, "%.0f", g_fDamageTaken[iIDVictim])
		
		remove_task(iIDVictim + g_iIDTaskResetTaken)
		set_task(2.0, "fwTaskDamageResetTaken", iIDVictim + g_iIDTaskResetTaken)
	}
	
	if (is_user_connected(iIDAttacker) && !bitsum_get(g_iBsDontShow, iIDAttacker))//(1 <= iIDAttacker <= g_iMaxPlayers) && 
	{
		//set_hudmessage(0, 255, 255, 0.3, 0.45, 1, 1.757, 0.0, 0.0, 1.757, -1)
		//ShowSyncHudMsg(iIDAttacker, g_iIDMsgSyncHud, "%d", fDamage)
		
		g_fDamageGiven[iIDAttacker] += fDamage;
		
		set_hudmessage(0, 255, 0, 0.3, 0.35, 1, 2.0, 0.0, 0.0, 2.0, 4)
		
		if (1 <= iIDVictim <= g_iMaxPlayers)
			ShowSyncHudMsg(iIDAttacker, g_iIDMsgSyncHud, "%.0f", g_fDamageGiven[iIDAttacker])
		else
			ShowSyncHudMsg(iIDAttacker, g_iIDMsgSyncHud, "%.2f", g_fDamageGiven[iIDAttacker])
		
		remove_task(iIDAttacker + g_iIDTaskResetGiven)
		set_task(2.0, "fwTaskDamageResetGiven", iIDAttacker + g_iIDTaskResetGiven)
	}
}

public fwTaskDamageResetTaken(const iIDTask)
	g_fDamageTaken[iIDTask - g_iIDTaskResetTaken] = 0.0;

public fwTaskDamageResetGiven(const iIDTask)
	g_fDamageGiven[iIDTask - g_iIDTaskResetGiven] = 0.0;
